<?php


class ControllerExtensionPaymentaamarpay extends Controller {
	private $error = array();

	public function index() {
		$this->load->language('extension/payment/aamarpay');

		$this->document->setTitle($this->language->get('heading_title'));

		$this->load->model('setting/setting');

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
			$this->model_setting_setting->editSetting('payment_aamarpay', $this->request->post);

			$this->session->data['success'] = $this->language->get('text_success');

			$this->response->redirect($this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', 'SSL'));
		}


 		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset($this->error['merchant'])) {
			$data['error_merchant'] = $this->error['merchant'];
		} else {
			$data['error_merchant'] = '';
		}
		if (isset($this->error['password'])) {
			$data['error_password'] = $this->error['password'];
		} else {
			$data['error_password'] = '';
		}

  		$data['breadcrumbs'] = array();

   		$data['breadcrumbs'][] = array(
       		'text'      => $this->language->get('text_home'),
			'href' => $this->url->link('common/home', 'user_token=' . $this->session->data['user_token'], 'SSL'),
      		'separator' => false
   		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_extension'),
			'href' => $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', 'SSL'),
			'separator' => ' :: '
		);

   		$data['breadcrumbs'][] = array(
       		'text'      => $this->language->get('heading_title'),
			'href'      => $this->url->link('extension/payment/aamarpay', 'user_token=' . $this->session->data['user_token'], 'SSL'),
      		'separator' => ' :: '
   		);

		$data['action'] = $this->url->link('extension/payment/aamarpay', 'user_token=' . $this->session->data['user_token'], 'SSL');

		$data['cancel'] = $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', 'SSL');
		

		if (isset($this->request->post['payment_aamarpay_merchant'])) {
			$data['payment_aamarpay_merchant'] = $this->request->post['payment_aamarpay_merchant'];
		} else {
			$data['payment_aamarpay_merchant'] = $this->config->get('payment_aamarpay_merchant');
		}

		if (isset($this->request->post['payment_aamarpay_password'])) {
			$data['payment_aamarpay_password'] = $this->request->post['payment_aamarpay_password'];
		} else {
			$data['payment_aamarpay_password'] = $this->config->get('payment_aamarpay_password');
		}

		if (isset($this->request->post['payment_aamarpay_test'])) {
			$data['payment_aamarpay_test'] = $this->request->post['payment_aamarpay_test'];
		} else {
			$data['payment_aamarpay_test'] = $this->config->get('payment_aamarpay_test');
		}

		if (isset($this->request->post['payment_aamarpay_total'])) {
			$data['payment_aamarpay_total'] = $this->request->post['payment_aamarpay_total'];
		} else {
			$data['payment_aamarpay_total'] = $this->config->get('payment_aamarpay_total');
		}

		if (isset($this->request->post['payment_aamarpay_order_status_id'])) {
			$data['payment_aamarpay_order_status_id'] = $this->request->post['payment_aamarpay_order_status_id'];
		} else {
			$data['payment_aamarpay_order_status_id'] = $this->config->get('payment_aamarpay_order_status_id');
		}
        if (isset($this->request->post['payment_aamarpay_order_fail_id'])) {
			$data['payment_aamarpay_order_fail_id'] = $this->request->post['payment_aamarpay_order_fail_id'];
		} else {
			$data['payment_aamarpay_order_fail_id'] = $this->config->get('payment_aamarpay_order_fail_id');
		}
		
		if (isset($this->request->post['payment_Aamarpay_order_risk_id'])) {
			$data['payment_aamarpay_order_risk_id'] = $this->request->post['payment_aamarpay_order_risk_id'];
		} else {
			$data['payment_aamarpay_order_risk_id'] = $this->config->get('payment_aamarpay_order_risk_id');
		}
                
		$this->load->model('localisation/order_status');

		$data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();

		if (isset($this->request->post['payment_aamarpay_geo_zone_id'])) {
			$data['payment_aamarpay_geo_zone_id'] = $this->request->post['payment_aamarpay_geo_zone_id'];
		} else {
			$data['payment_aamarpay_geo_zone_id'] = $this->config->get('payment_aamarpay_geo_zone_id');
		}

		
		$this->load->model('localisation/geo_zone');

		$data['geo_zones'] = $this->model_localisation_geo_zone->getGeoZones();

		if (isset($this->request->post['payment_aamarpay_status'])) {
			$data['payment_aamarpay_status'] = $this->request->post['payment_aamarpay_status'];
		} else {
			$data['payment_aamarpay_status'] = $this->config->get('payment_aamarpay_status');
		}

		if (isset($this->request->post['payment_Aamarpay_sort_order'])) {
			$data['payment_aamarpay_sort_order'] = $this->request->post['payment_aamarpay_sort_order'];
		} else {
			$data['payment_aamarpay_sort_order'] = $this->config->get('payment_aamarpay_sort_order');
		}
		
        $data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');
  
             /* admin/view/template/extension/payment/aamarpay.twig */
  
		$this->response->setOutput($this->load->view('extension/payment/aamarpay', $data));
		
	}

	private function validate() {
		if (!$this->user->hasPermission('modify', 'extension/payment/aamarpay')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		if (!$this->request->post['payment_aamarpay_merchant']) {
			$this->error['merchant'] = $this->language->get('error_merchant');
		}
		if (!$this->request->post['payment_aamarpay_password']) {
			$this->error['password'] = $this->language->get('error_password');
		}

		if (!$this->error) {
			return true;
		} else {
			return false;
		}
	}
}
?>