<?php
class ControllerExtensionPaymentaamarpay extends Controller {
	
	public function index() {
		$data['button_confirm'] = $this->language->get('button_confirm');

		$this->load->model('checkout/order');

		$order_info = $this->model_checkout_order->getOrder($this->session->data['order_id']);

		$data['store_id'] = $this->config->get('payment_aamarpay_merchant');
		$data['tran_id'] = $this->session->data['order_id'];
		$data['total_amount'] = $this->currency->format($order_info['total'], $order_info['currency_code'], $order_info['currency_value'], false);
		
		$data['signature_key'] = $this->config->get('payment_aamarpay_password');

		$data['cus_name'] = $order_info['payment_firstname'] . ' ' . $order_info['payment_lastname'];
		$data['cus_add1'] = $order_info['payment_address_1'];
		$data['cus_add2'] = $order_info['payment_address_2'];
		$data['cus_city'] = $order_info['payment_city'];
		$data['cus_state'] = $order_info['payment_zone'];
		$data['cus_postcode'] = $order_info['payment_postcode'];
		$data['cus_country'] = $order_info['payment_country'];
		$data['cus_phone'] = $order_info['telephone'];
		$data['cus_email'] = $order_info['email'];

		if ($this->cart->hasShipping()) {
			$data['ship_name'] = $order_info['shipping_firstname'] . ' ' . $order_info['shipping_lastname'];
			$data['ship_add1'] = $order_info['shipping_address_1'];
			$data['ship_add2'] = $order_info['shipping_address_2'];
			$data['ship_city'] = $order_info['shipping_city'];
			$data['ship_state'] = $order_info['shipping_zone'];
			$data['ship_postcode'] = $order_info['shipping_postcode'];
			$data['ship_country'] = $order_info['shipping_country'];
		} else {
			$data['ship_name'] = '';
			$data['ship_add1'] = '';
			$data['ship_add2'] = '';
			$data['ship_city'] = '';
			$data['ship_state'] = '';
			$data['ship_postcode'] = '';
			$data['ship_country'] = '';
		}
              
		$data['currency'] = $this->config->get('config_currency');
		$data['success_url'] = $this->url->link('extension/payment/aamarpay/callback', '', 'SSL');
        $data['fail_url'] = $this->url->link('checkout/failure', '', 'SSL');
        $data['cancel_url'] = $this->url->link('checkout/cart', '', 'SSL');
		
		$security_key = $this->config->get('payment_aamarpay_password');
		
		$data['signature_key'] = $security_key;
        

		
		
		$products = '';
		
		
		foreach ($this->cart->getProducts() as $product) {
    		$products .= $product['quantity'] . ' x ' . $product['name'] . ', ';
    	}		
		
		$data['detail1_text'] = $products;
		
		
		if($this->config->get('payment_aamarpay_test')=='live') {
				$data['process_url'] = 'https://secure.aamarpay.com/index.php';
			}
		else {
				$data['process_url'] = 'https://sandbox.aamarpay.com/index.php';
			}


		if (file_exists(DIR_TEMPLATE . $this->config->get('config_template') . '/template/extension/payment/aamarpay')) {
			return $this->load->view($this->config->get('config_template') . '/template/extension/payment/aamarpay', $data);
		} else {
			return $this->load->view('extension/payment/aamarpay', $data);
		}
	}
	
	
	public function callback() {
	  
                
				$aamarpay_test = $this->config->get('payment_aamarpay_test');
                $store_id = urldecode($this->config->get('payment_aamarpay_merchant'));
                $store_passwd = urldecode($this->config->get('payment_aamarpay_password'));
                
               if (isset($_POST['mer_txnid'])) {
					$order_id = $_POST['mer_txnid'];
					
				} else {
					$order_id = 0;
				}
                if (isset($_POST['amount'])) {
                    $total=$_POST['amount'];
					
				}else
                	{
                    $total='';	
                   
                }
				if(isset($_POST['val_id'])){
					$val_id = urldecode($_POST['val_id']); 
					}
				else {
					 $val_id = ''; 
					}
					
					
					
		$this->load->model('checkout/order');
		$order_info = $this->model_checkout_order->getOrder($order_id);
		
        $amount = $this->currency->format($order_info['total'], $order_info['currency_code'], $order_info['currency_value'], false);
      
                                       
        
if(empty($val_id)){
						if($this->config->get('payment_aamarpay_test')=='live') {
						  $valid_url_own = ("https://secure.aamarpay.com/index.php"); 
						 
						  } else{
							 $valid_url_own = ("https://sandbox.aamarpay.com/index.php");  
						  }
						 
			$ownvalid = curl_init();
			curl_setopt($ownvalid, CURLOPT_URL, $valid_url_own);
			curl_setopt($ownvalid, CURLOPT_RETURNTRANSFER, true);
			curl_setopt($ownvalid, CURLOPT_SSL_VERIFYHOST, false);
			curl_setopt($ownvalid, CURLOPT_SSL_VERIFYPEER, false);
			
			$ownvalid_result = curl_exec($ownvalid);
			
			$ownvalid_code = curl_getinfo($ownvalid, CURLINFO_HTTP_CODE);
			
			if($ownvalid_code == 200 && !( curl_errno($ownvalid)))
			{
				$result_own = json_decode($ownvalid_result, true);
				$lastupdate_no = $result_own['no_of_trans_found']-1;	
				$own_data = $result_own['element']; 
				$val_id = $own_data[$lastupdate_no]['val_id'];
				//echo $own_data[0]['val_id'];
			}
						 
					 
						 
}


			
                if($this->config->get('payment_aamarpay_test')=='live') {
                $requested_url = ("https://secure.aamarpay.com/api/v1/trxcheck/request.php?request_id=$order_id&store_id=$store_id&signature_key=$store_passwd&type=json");
                } else{
               $requested_url = ("");  
                }  
				
                $amount = $this->currency->format($order_info['total'], $order_info['currency_code'], $order_info['currency_value'], false);
                $handle = curl_init();
curl_setopt($handle, CURLOPT_URL, $requested_url);
curl_setopt($handle, CURLOPT_RETURNTRANSFER, true);


$result = curl_exec($handle);

$code = curl_getinfo($handle, CURLINFO_HTTP_CODE);

if($code == 200 && !( curl_errno($handle)))
{	

	# TO CONVERT AS ARRAY
	# $result = json_decode($result, true);
	# $status = $result['status'];	
	
	# TO CONVERT AS OBJECT
	$result = json_decode($result);
// 		print_r($result);
// exit;
	# TRANSACTION INFO
	$status = $result->pay_status;	

	$tran_date = $result->date;
	$tran_id = $result->mer_txnid;
	$val_id = $result->mer_txnid;
	$amount = $result->amount;
	$store_amount = $result->rec_amount;
	$bank_tran_id = $result->bank_trxid;
	$card_type = $result->payment_type;
	
	# ISSUER INFO
	$card_no = $result->cardnumber;
	$card_issuer = $result->bin_issuer;
	$card_brand = $result->bin_cardtype;
	$card_issuer_country = $result->bin_country;
	$card_issuer_country_code = $result->bin_cardcategory;   
	
	//Payment Risk Status
	$risk_level = $result->risk_level;
	$risk_title = $result->risk_title;
	

                    if($status=='Successful')
                    {
                        if($risk_level==0){ $status = 'success';}
                        if($risk_level==1){ $status = 'risk';} 
                    }
                    elseif($status=='VALIDATED'){
                        if($risk_level==0){ $status = 'success';}
                        if($risk_level==1){ $status = 'risk';} 
                     }
                    else
                    {
                         $status = 'failed';
                    }
                }
// print_r($result);
// exit;

 $data['breadcrumbs'] = array();

			$data['breadcrumbs'][] = array(
				'text' => $this->language->get('text_home'),
				'href' => $this->url->link('common/home')
			);

			$data['breadcrumbs'][] = array(
				'text' => $this->language->get('text_basket'),
				'href' => $this->url->link('checkout/cart')
			);

			$data['breadcrumbs'][] = array(
				'text' => $this->language->get('text_checkout'),
				'href' => $this->url->link('checkout/checkout', '', 'SSL')
			);

			$data['breadcrumbs'][] = array(
				'text' => $this->language->get('text_failed'),
				'href' => $this->url->link('checkout/success')
			);

			$data['heading_title'] = $this->language->get('text_failed');

			
			$data['button_continue'] = $this->language->get('button_continue');
				
		if ($order_info && $status) {
			$this->language->load('extension/payment/aamarpay');
	
			$data['title'] = sprintf($this->language->get('heading_title'), $this->config->get('config_name'));
	
			if (!isset($this->request->server['HTTPS']) || ($this->request->server['HTTPS'] != 'on')) {
				$data['base'] = HTTP_SERVER;
			} else {
				$data['base'] = HTTPS_SERVER;
			}
	
			$data['language'] = $this->language->get('code');
			$data['direction'] = $this->language->get('direction');
	
			$data['heading_title'] = sprintf($this->language->get('heading_title'), $this->config->get('config_name'));
	
			$data['text_response'] = $this->language->get('text_response');
			$data['text_success'] = $this->language->get('text_success');
			$data['text_success_wait'] = sprintf($this->language->get('text_success_wait'), $this->url->link('checkout/success'));
			$data['text_failure'] = $this->language->get('text_failure');
			$data['text_failure_wait'] = sprintf($this->language->get('text_failure_wait'), $this->url->link('checkout/cart'));
	
	

			if (isset($status) && $status == 'success') {

				$this->load->model('checkout/order');
	
				 $this->model_checkout_order->addOrderHistory($_POST['mer_txnid'], $this->config->get('config_order_status_id'));

				$message = '';
	
				
					$message .= 'Payment Status = ' . $status . "\n";
				    
					$message .= 'Bank txnid = ' . $bank_tran_id . "\n";
				   
					$message .= 'Your Oder id = ' . $tran_id . "\n";
					
					$message .= 'Payment Date = ' . $tran_date . "\n";  
				   
					$message .= 'Card Number = ' .$card_no . "\n"; 
				   
					$message .= 'Card Type = ' .$card_brand .'-'. $card_type . "\n"; 
				    
					$message .= 'Transaction Risk Level = ' .$risk_level . "\n"; 
				   
					$message .= 'Transaction Risk Description = ' .$risk_title . "\n"; 
	
                   $this->model_checkout_order->addOrderHistory($order_id, $this->config->get('payment_aamarpay_order_status_id'), $message, false);
	$error='';
                    $data['text_message'] = sprintf('your payment was successfully received', $error, $this->url->link('information/contact'));
			$data['continue'] = $this->url->link('checkout/success');
            $data['column_left'] = $this->load->controller('common/column_left');
			$data['column_right'] = $this->load->controller('common/column_right');
			$data['content_top'] = $this->load->controller('common/content_top');
			$data['content_bottom'] = $this->load->controller('common/content_bottom');
			$data['footer'] = $this->load->controller('common/footer');
			$data['header'] = $this->load->controller('common/header');
// 		//$this->response->setOutput($this->load->view('extension/payment/success', $data));
// 		exit;
             
			if (file_exists(DIR_TEMPLATE . $this->config->get('config_template') . '/template/extension/payment/success')) {
			
				$this->response->setOutput($this->load->view($this->config->get('config_template') . '/template/extension/payment/success', $data));
			} else {
			    
				$this->response->setOutput($this->load->view('extension/payment/Aamarpay_success', $data));
				
			}
			
			}
			else if (isset($status) && $status == 'risk') {
				$this->load->model('checkout/order');
	
				$this->model_checkout_order->addOrderHistory($_POST['tran_id'], $this->config->get('config_order_status_id'));
	
				$message = '';
	
				
					$message .= 'Payment Status = ' . $status . "\n";
				    
					$message .= 'Bank txnid = ' . $bank_tran_id . "\n";
				   
					$message .= 'Your Oder id = ' . $tran_id . "\n";
					
					$message .= 'Payment Date = ' . $tran_date . "\n";  
				   
					$message .= 'Card Number = ' .$card_no . "\n"; 
				   
					$message .= 'Card Type = ' .$card_brand .'-'. $card_type . "\n"; 
				    
					$message .= 'Transaction Risk Level = ' .$risk_level . "\n"; 
				   
					$message .= 'Transaction Risk Description = ' .$risk_title . "\n"; 
					
	            $this->model_checkout_order->addOrderHistory($order_id, $this->config->get('payment_aamarpay_order_risk_id'), $message, false);
				$this->model_checkout_order->update($order_id, $this->config->get('payment_aamarpay_order_risk_id'), $message, false);
	
				$data['continue'] = $this->url->link('checkout/checkout');
            $data['column_left'] = $this->load->controller('common/column_left');
			$data['column_right'] = $this->load->controller('common/column_right');
			$data['content_top'] = $this->load->controller('common/content_top');
			$data['content_bottom'] = $this->load->controller('common/content_bottom');
			$data['footer'] = $this->load->controller('common/footer');
			$data['header'] = $this->load->controller('common/header');

				if (file_exists(DIR_TEMPLATE . $this->config->get('config_template') . '/template/extension/payment/Commerce_risk')) {
					$this->response->setOutput($this->load->view($this->config->get('config_template') . '/template/extension/payment/Commerce_risk', $data));
				} else {
					$this->response->setOutput($this->load->view('extension/payment/Commerce_risk', $data));
				}

			} else {
				
				
				
				
				
			$data['continue'] = $this->url->link('checkout/cart');
            $data['column_left'] = $this->load->controller('common/column_left');
			$data['column_right'] = $this->load->controller('common/column_right');
			$data['content_top'] = $this->load->controller('common/content_top');
			$data['content_bottom'] = $this->load->controller('common/content_bottom');
			$data['footer'] = $this->load->controller('common/footer');
			$data['header'] = $this->load->controller('common/header');

			if (file_exists(DIR_TEMPLATE . $this->config->get('config_template') . '/template/extension/payment/Commerce_failure')) {
				$this->response->setOutput($this->load->view($this->config->get('config_template') . '/template/extension/payment/Commerce_failure', $data));
			} else {
				$this->response->setOutput($this->load->view('extension/payment/Commerce_failure', $data));
			}
	

			}
		}
	}

		

}
